<?
	/*
		news.php
		
		SQL-based news reading library

		Copyright (C) 2000,2001 Jeff Teunissen <deek@quakeforge.net>
		Copyright (C) 2000 Daniel David Olson <theoddone33@users.sourceforge.net>

		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

		See the GNU General Public License for more details.

		You should have received a copy of the GNU General Public License
		along with this program; if not, write to:

		Free Software Foundation, Inc.
		59 Temple Place - Suite 330
		Boston, MA  02111-1307, USA.
	*/

	have ('news');

/*									SQL definition for news table
CREATE TABLE news_main (
	n_id    INT NOT NULL PRIMARY KEY AUTO_INCREMENT,
	n_user  TINYTEXT NOT NULL,
	n_date  TIMESTAMP NOT NULL DEFAULT NOW(),
	n_news  TEXT DEFAULT '' NOT NULL
);
*/
	function newsItem ($date, $user, $text)
	{
		echo
			'	<DL>' .
			'		<DT><FONT SIZE="-1">' . "<EM>Posted on </EM>$date<EM> by </EM><STRONG>$user</STRONG></FONT></DT>" .
			"		<DD><P>$text</P></DD>" .
			'	</DL>' ;
	}

	function newsEntry ($array)
	{
		need ("date");
		
		return
			'	<DL>' .
			'		<DT><FONT size="-1"><EM>Posted on </EM>' . dateFromSQLDateTime ($array[n_date]) . '<EM> by </EM><STRONG>' . $array[n_user] . '</STRONG></FONT></DT>' .
			'		<DD>' . StripSlashes ($array[n_news]) . '</DD>' .
			'	</DL>';
	}

	function monthForm ($month, $year)
	{
		need ('feature');

		// suppress warnings
		@featureOpen ('Date Search');
		?>
			<FORM name="bymonth" method="get" action="<?=thisURL?>">
				<P align="center">
				<SELECT name="month">
				<?
					for ( $i = 1 ; $i < 13 ; $i++ ) {
						printf ("<OPTION%s>%02d</OPTION>", $i == $month ? " selected" : "", $i);
					}
				?>
				</SELECT><STRONG> / </STRONG><SELECT name="year">
				<?
					if ($year == "")
						$year = date ('Y');
					for ($i = 1999; $i <= date ('Y'); $i++ ) {
						printf ("<OPTION%s>%04d</OPTION>", $i == $year ? " selected" : "", $i);
					}
				?>
				</SELECT>
				<BR>
				<BR>
				<INPUT type="submit" value="Search">
				</P>
			</FORM><?
		featureClose ();
	}

	function keywordForm ($string)
	{
		need ('feature');

		// suppress warnings
		@featureOpen ('Keyword Search');
		?>
			<FORM name="bystring" method="get" action="<?=thisURL?>">
				<P align="center">
				<?
					printf ('<INPUT name="string" type="text" size="16" value="%s">', $string);
				?>
				<BR>
				<BR>
				<INPUT TYPE="submit" VALUE="Search">
				</P>
			</FORM><?
		featureClose ();
	}

	function fetchNewsEntry ($number)
	{
		need('date');

			$conn = @mysql_pconnect (sqlHost, sqlUser, sqlPass);
			if ($conn) {
				$query = 'SELECT n_date, n_user, n_news FROM news_main' .
						" ORDER BY n_date DESC LIMIT $number";
				$result = @mysql_db_query (sqlDB, $query, $conn);
				if ($result) {
					$numRows = @mysql_num_rows ($result);
					if ($numRows) {
						for ($i = 0 ; $i < $numRows ; $i++) {
							list ($n_date, $n_user, $n_news) = mysql_fetch_row ($result);
						}
					} else {
						return 0;
					}
				} else {
					return 0;
				}
				mysql_close ($conn);
			} else {
				return 0;
			}
	//		return (list (dateFromSQLDateTime ($n_date), $n_user, StripSlashes($n_news)));
		return 0;
	}

	function latestNews ($max)
	{
		if (sqlAvail) {
			$conn = mysql_pconnect (sqlHost, sqlUser, sqlPass);
			if ($conn) {
				$query = 'SELECT n_date, n_user, n_news FROM news_main' .
						' ORDER BY n_date DESC';
				$result = mysql_db_query (sqlDB, $query, $conn);
				if ($result) {
					$numRows = mysql_num_rows ($result);
					if ($numRows) {
						for ($i = 0 ; $i < $numRows  && $i < $max; $i++) {
							$news[$i] = mysql_fetch_array ($result);
							echo newsEntry ($news[$i]);
						}
					} else {
						newsItem (date ('d M Y'), 'Web Server', '<P>No current news!');
					}
				} else {
					newsItem (date ('d M Y'), 'Web Server', '<P>No news in database!');
				}
				mysql_close ($conn);
			} else {
				include 'newscache.php';
				return 1;
			}
			return 0;
		} else {
			newsItem (date ('d M Y'), 'Web Server', '<P>No SQL server available!');
			return 0;
		}
	}
	
	function monthlyNews ($month, $year)
	{
		if (($year < 1999) || ($year > date ('Y'))) {	// Sanity checking
			$year = date ('Y');
		}
		
		if (($month < 1) || ($month > 12)) {
			$month = date ('m');
		}

		$date1 = sprintf ("%04d-%02d", $year, $month);
		$date2 = sprintf ("%04d-%02d", $year, $month+1);

		if (sqlAvail) {
			$conn = mysql_pconnect (sqlHost, sqlUser, sqlPass);
			if ($conn) {
				$query = 'SELECT n_date, n_user, n_news FROM news_main' .
						" WHERE n_date BETWEEN '$date1-01 00:00:00'" .
						" AND '$date2-01 00:00:00'" .
						' ORDER BY n_date DESC';
				$result = @mysql_db_query (sqlDB, $query, $conn);
				if ($result) {
					$numRows = @mysql_num_rows ($result);
					if ($numRows) {
						for ($i = 0 ; $i < $numRows ; $i++) {
							$news[$i] = mysql_fetch_array ($result);
							echo newsEntry ($news[$i]);
						}
					} else {
						newsItem (date ('d M Y'), 'Web Server', '<P>No news for this month!');
					}
				} else {
					newsItem (date ('d M Y'), 'Web Server', '<P>No news in database!');
				}
				mysql_close ($conn);
			} else {
				newsItem (date ('d M Y'), 'Web Server', '<STRONG>SQL error!</STRONG> Please contact the <A href="mailto:deek@quakeforge.net">Webmaster</A>.');
			}
		} else {
			newsItem (date ('d M Y'), 'Web Server', '<P>No SQL server available');
		}
	}

	function searchNews ($string)
	{
		if (sqlAvail) {
			$search = AddSlashes ("%$string%");
			$conn = mysql_pconnect (sqlHost, sqlUser, sqlPass);
			if ($conn) {
				$query = 'SELECT n_date, n_user, n_news FROM news_main' .
						" WHERE n_news LIKE '$search'" .
						' ORDER BY n_date DESC';
				$result = mysql_db_query (sqlDB, $query, $conn);
				if ($result) {
					$numRows = mysql_num_rows ($result);
					if ($numRows) {
						for ($i = 0 ; $i < $numRows ; $i++) {
							$news[$i] = mysql_fetch_array ($result);
							echo newsEntry ($news[$i]);
						}
					} else {
						newsItem (date ('d M Y'), 'Web Server', "No news found matching '$string'");
					}
				} else {
					newsItem (date ('d M Y'), 'Web Server', "No news found matching '$string'");
				}
				mysql_close ($conn);
			} else { 
				newsItem (date ('d M Y'), 'Web Server', '<STRONG>SQL error!</STRONG> Please contact the <A href="mailto:deek@quakeforge.net">Webmaster</A>.');
			}
		} else {
			newsItem (date ('d M Y'), 'Web Server', '<P>No SQL server available');
		}
	}

?>
